%global app_root %{_datadir}/%{name}

Summary: Deltacloud REST API
Name: deltacloud-core
Version: 1.0.5
Release: 1%{?dist}
Group: Development/Languages
License: ASL 2.0 and MIT
URL: http://deltacloud.org
Source0: http://apache.mirror.rbftpnetworks.com/deltacloud/stable/%{name}-%{version}.gem
Source1: deltacloudd-fedora
Source2: deltacloud-core-config
Source3: deltacloud-core.service
Patch0: d8c9a4450623477e3b35e5223a082ff9ced35c0a-1.0.5.patch
Requires: ruby(rubygems)
Requires: ruby(abi) = 1.9.1
Requires: rubygem(haml)
Requires: rubygem(sinatra) >= 1.0
Requires: rubygem(rack) >= 1.1.0
Requires: rubygem(thin)
Requires: rubygem(net-ssh)
Requires: rubygem(json) >= 1.4.0
Requires: rubygem(rack-accept)
Requires: rubygem(nokogiri)
Requires: rubygem(sinatra-rabbit)
Requires: rubygem(crack)
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
Requires(post): systemd-sysv
BuildRequires: rubygems-devel
BuildRequires: ruby(abi) = 1.9.1
BuildRequires: rubygem(haml)
BuildRequires: rubygem(sinatra) >= 1.0
BuildRequires: rubygem(nokogiri)
BuildRequires: rubygem(tilt)
BuildRequires: rubygem(net-ssh)
BuildRequires: rubygem(aws)
BuildRequires: rubygem(rack-accept)
BuildRequires: rubygem(rake) >= 0.8.7
BuildRequires: rubygem(rack)
BuildRequires: rubygem(rack-test)
BuildRequires: rubygem(json)
BuildRequires: rubygem(minitest)
BuildRequires: rubygem(sinatra-rabbit)
BuildRequires: rubygem(crack)
BuildArch: noarch
Obsoletes: rubygem-deltacloud-core

%description
The Deltacloud API is built as a service-based REST API.
You do not directly link a Deltacloud library into your program to use it.
Instead, a client speaks the Deltacloud API over HTTP to a server
which implements the REST interface.

%package doc
Summary: Documentation for %{name}
Group: Documentation
Requires: %{name} = %{version}-%{release}

%description doc
Documentation for %{name}

%package all
Summary: Deltacloud Core with all drivers
Requires: %{name} = %{version}-%{release}
Requires: %{name}-ec2
Requires: %{name}-eucalyptus
Requires: %{name}-gogrid
Requires: %{name}-opennebula
Requires: %{name}-rackspace
Requires: %{name}-rimuhosting
Requires: %{name}-rhevm
Requires: %{name}-sbc
Requires: %{name}-vsphere
Requires: %{name}-google
Requires: %{name}-openstack
Requires: %{name}-fgcp

%description all
Deltacloud core with all available drivers

%package google
Summary: Deltacloud Core for Google storage
Requires: %{name} = %{version}-%{release}
Requires: rubygem(fog)

%description google
The google sub-package brings in all dependencies necessary to use deltacloud
core to connect to Google Storage.

%package ec2
Summary: Deltacloud Core for EC2
Requires: %{name} = %{version}-%{release}
Requires: rubygem(aws)

%description ec2
The ec2 sub-package brings in all dependencies necessary to use deltacloud
core to connect to EC2.

%package eucalyptus
Summary: Deltacloud Core for Eucalyptus
Requires: %{name} = %{version}-%{release}
Requires: rubygem(aws)

%description eucalyptus
The eucalyptus sub-package brings in all dependencies necessary to use deltacloud
core to connect to EC2.

%package gogrid
Summary: Deltacloud Core for GoGrid
Requires: %{name} = %{version}-%{release}

%description gogrid
The gogrid sub-package brings in all dependencies necessary to use deltacloud
core to connect to GoGrid.

%package opennebula
Summary: Deltacloud Core for OpenNebula
Requires: %{name} = %{version}-%{release}

%description opennebula
The opennebula sub-package brings in all dependencies necessary to use
deltacloud core to connect to OpenNebula.

%package rackspace
Summary: Deltacloud Core for Rackspace
Requires: %{name} = %{version}-%{release}
Requires: rubygem(cloudfiles)
Requires: rubygem(cloudservers)

%description rackspace
The rackspace sub-package brings in all dependencies necessary to use deltacloud
core to connect to Rackspace.

%package openstack
Summary: Deltacloud Core for OpenStack
Requires: %{name} = %{version}-%{release}
Requires: rubygem(openstack)

%description openstack
The rackspace sub-package brings in all dependencies necessary to use deltacloud
core to connect to OpenStack.

%package rhevm
Summary: Deltacloud Core for RHEV-M
Requires: %{name} = %{version}-%{release}
Requires: rubygem(rest-client)
Requires: rubygem(rbovirt)

%description rhevm
The rhevm sub-package brings in all dependencies necessary to use deltacloud
core to connect to RHEV-M.

%package rimuhosting
Summary: Deltacloud Core for Rimuhosting
Requires: %{name} = %{version}-%{release}

%description rimuhosting
The rimuhosting sub-package brings in all dependencies necessary to use
deltacloud core to connect to Rimuhosting.

%package sbc
Summary: Deltacloud Core for SBC
Requires: %{name} = %{version}-%{release}

%description sbc
The sbc sub-package brings in all dependencies necessary to use deltacloud core
to connect to SBC.

%package vsphere
Summary: Deltacloud Core for vSphere
Requires: %{name} = %{version}-%{release}
Requires: rubygem(rbvmomi)
Requires: genisoimage

%description vsphere
The vsphere sub-package brings in all dependencies necessary to use deltacloud
core to connect to VMware vSphere.

%package fgcp
Summary: Deltacloud Core for Fujitsu Global Cloud Platform
Requires: %{name} = %{version}-%{release}
Requires: rubygem(xml-simple)

%description fgcp
The fgcp sub-package brings in all dependencies necessary to use deltacloud
core to connect to Fujitsu Global Cloud Platform (FGCP).

%prep
%setup -q -c -T
gem unpack -V --target=%{_builddir} %{SOURCE0}
pushd %{_builddir}/%{name}-%{version}
%patch0 -p1
popd

%triggerun -- deltacloud-core < 1.0-1
/usr/bin/systemd-sysv-convert --save deltacloud-core >/dev/null 2>&1 ||:
/bin/systemctl --no-reload enable deltacloud-core.service >/dev/null 2>&1 ||:
/sbin/chkconfig --del deltacloud-core >/dev/null 2>&1 || :
/bin/systemctl try-restart deltacloud-core.service >/dev/null 2>&1 || :

%build

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{app_root}
mkdir -p %{buildroot}%{_unitdir}
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
cp -r %{_builddir}/%{name}-%{version}/* %{buildroot}%{app_root}
install -m 0755 %{SOURCE1} %{buildroot}%{_bindir}/deltacloudd
install -m 0655 %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/%{name}
install -m 0655 %{SOURCE3} %{buildroot}%{_unitdir}/%{name}.service
find %{buildroot}%{app_root}/lib -type f | xargs chmod -x
chmod -x %{buildroot}%{_sysconfdir}/sysconfig/%{name}
chmod 0755 %{buildroot}%{app_root}/bin/deltacloudd

# Temporary remove Azure drivers until all dependencies will be pushed in to Fedora
rm %{buildroot}%{app_root}/config/drivers/azure.yaml
rm %{buildroot}%{app_root}/config/drivers/condor.yaml
rm %{buildroot}%{app_root}/config/condor.yaml
rm %{buildroot}%{app_root}/config/addresses.xml
rm %{buildroot}%{app_root}/config/drivers/terremark.yaml
rm %{buildroot}%{app_root}/config/drivers/aruba.yaml

rdoc --op %{buildroot}%{_defaultdocdir}/%{name} &> /dev/null

mkdir -p %{buildroot}%{_localstatedir}/log/%{name}

# the condor stuff is provided by the condor-cloud package; it really doesn't
# belong in deltacloud, but until it is removed from upstream we just manually
# delete it here
rm -rf %{buildroot}%{app_root}/support/condor
rm -rf %{buildroot}%{app_root}/support/fedora

%check
pushd %{buildroot}%{app_root}
ruby tests/deltacloud/*_test.rb
ruby tests/helpers/core_ext/*_test.rb
ruby tests/helpers/rack/*_test.rb
ruby tests/drivers/base/*_test.rb
ruby tests/drivers/mock/*_test.rb
ruby tests/drivers/models/*_test.rb
popd

%clean

%post
if [ $1 -eq 1 ] ; then 
    # Initial installation
    /bin/systemctl enable deltacloud-core.service >/dev/null 2>&1 || :
fi

%preun
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
    /bin/systemctl --no-reload disable deltacloud-core.service > /dev/null 2>&1 || :
    /bin/systemctl stop deltacloud-core.service > /dev/null 2>&1 || :
fi

%postun
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
    # Package upgrade, not uninstall
    /bin/systemctl try-restart deltacloud-core.service >/dev/null 2>&1 || :
fi

%files
%{_unitdir}/%{name}.service
%{_bindir}/deltacloudd
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%dir %{app_root}/
%{app_root}/bin
%{app_root}/config.ru
%{app_root}/views
%{app_root}/lib
%dir %{app_root}/config/drivers
%{app_root}/config/drivers/mock.yaml
%dir %{app_root}/public
%{app_root}/public/images
%{app_root}/public/stylesheets
%{app_root}/public/favicon.ico
%doc %{app_root}/NOTICE
%doc %{app_root}/LICENSE
# MIT
%{app_root}/public/javascripts
%dir %attr(0755, nobody, nobody) %{_localstatedir}/log/%{name}

%files doc
%{_defaultdocdir}/%{name}
%{app_root}/tests
%{app_root}/%{name}.gemspec
%{app_root}/Rakefile

%files all

%files ec2
%{app_root}/config/drivers/ec2.yaml

%files eucalyptus
%{app_root}/config/drivers/eucalyptus.yaml

%files gogrid
%{app_root}/config/drivers/gogrid.yaml

%files opennebula
%{app_root}/config/drivers/opennebula.yaml

%files rackspace
%{app_root}/config/drivers/rackspace.yaml

%files openstack
%{app_root}/config/drivers/openstack.yaml

%files rhevm
%{app_root}/config/drivers/rhevm.yaml

%files rimuhosting
%{app_root}/config/drivers/rimuhosting.yaml

%files sbc
%{app_root}/config/drivers/sbc.yaml

%files vsphere
%{app_root}/config/drivers/vsphere.yaml

%files fgcp
%{app_root}/config/drivers/fgcp.yaml

%files google
%defattr(-, root, root, -)
%{app_root}/config/drivers/google.yaml

%changelog
* Tue Nov 27 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.5-1
- Release 1.0.5

* Tue Nov 13 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.4-2
- Added option to system config file to enable multiple
  frontends

* Mon Oct 29 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.4-1
- Release 1.0.4

* Tue Oct 02 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.3-2
- Fixed dependency but for OpenStack driver

* Mon Sep 17 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.3-1
- Release 1.0.3

* Thu Aug 16 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.2-0.2.rc1
- Version bump to 1.0.2rc1

* Tue Aug 07 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.2-0.1.20120807gitb16c65ce
- Version bump to 1.0.2 pre-release

* Wed Aug 01 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.0-8
- Fixed memory leaking on Ruby 1.9

* Tue Jul 31 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.0-7
- Fixed rubyabi version

* Tue Jul 31 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.0-6
- Added rbovirt gem dependency for RHEV-M

* Mon Jul 16 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.0-5
- Backported capability checking patches

* Tue Jun 26 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.0-4
- Updated old configuration file

* Tue Jun 26 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.0-3
- Added genisoimage require for VSphere driver (needed for user_data injection)

* Tue Jun 26 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.0-2
- Fixed xml-simple dependency name

* Mon Jun 25 2012 Michal Fojtik <mfojtik@redhat.com> - 1.0.0-1
- Update to 1.0.0 release

* Wed Feb 08 2012 Michal Fojtik <mfojtik@redhat.com> - 0.5.0-1
- Version bump 0.5.0 GA

* Mon Feb 06 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 0.5.0-3.rc1
- Rebuilt for Ruby 1.9.3.

* Wed Jan 11 2012 Michal Fojtik <mfojtik@redhat.com> - 0.5.0-2.rc1
- Fixed dependencies

* Thu Dec 15 2011 Michal Fojtik <mfojtik@redhat.com> - 0.5.0-1.rc1
- Updated to 0.5.1

* Thu Dec 15 2011 Michal Fojtik <mfojtik@redhat.com> - 0.4.1-7
- Removed rspec build dependency

* Fri Nov 11 2011 Michal Fojtik <mfojtik@redhat.com> - 0.4.1-6
- Fixed launcher and init script

* Tue Nov 08 2011 Michal Fojtik <mfojtik@redhat.com> - 0.4.1-5
- Backported validation fix for Rabbit BZ:750920

* Tue Nov 08 2011 Michal Fojtik <mfojtik@redhat.com> - 0.4.1-4
- Backported OpenStack driver

* Wed Oct 21 2011 Michal Fojtik <mfojtik@redhat.com> - 0.4.1-3
- Backported fix for VSphere driver

* Wed Oct 12 2011 Michal Fojtik <mfojtik@redhat.com> - 0.4.1-2
- Backported latest fixes in hardware profiles
- Backported Google Storage driver

* Wed Oct 12 2011 Michal Fojtik <mfojtik@redhat.com> - 0.4.1-1
- Version bump (0.4.1)

* Thu Sep 29 2011 Chris Lalancette <clalance@redhat.com> - 0.4.0-4
- Add a patch to re-enable deltacloud-core-condor

* Thu Sep 15 2011 Chris Lalancette <clalance@redhat.com> - 0.4.0-3
- Fixes to the initscript and release bump

* Thu Sep 15 2011 Chris Lalancette <clalance@redhat.com> - 0.4.0-2
- Update to 0.4.0 release

* Wed Sep 14 2011 Chris Lalancette <clalance@redhat.com> - 0.4.0-0.5.rc1
- Remember to actually include the log directory in files

* Wed Sep 14 2011 Chris Lalancette <clalance@redhat.com> - 0.4.0-0.4.rc1
- Bump release to add dist tag

* Wed Sep 14 2011 Chris Lalancette <clalance@redhat.com> - 0.4.0-0.3.rc1
- Add patches to fix up deltacloud-core initscript
- Clean up the specfile (sort subpackages in alphabetical order)
- Disable deltacloud-core-condor subpackage for now (since it doesn't work)
- Make sure the log directory is owned by nobody:nobody

* Wed Jul 17 2011 Michal Fojtik <mfojtik@redhat.com> - 0.4.0-0.2.rc1
- Removed mock subpackage since it's part of main deltacloud-core package

* Mon Jul 11 2011 Michal Fojtik <mfojtik@redhat.com> - 0.4.0-0.1.rc1
- Version bump to 0.4.0
- Added CondorCloud driver

* Mon Jul 11 2011 Michal Fojtik <mfojtik@redhat.com> - 0.3.0-11
- Added virtual package with all drivers

* Fri Jun 7 2011 Michal Fojtik <mfojtik@redhat.com> - 0.3.0-10
- Added patch to handle long usernames

* Fri Jun 3 2011 Michal Fojtik <mfojtik@redhat.com> - 0.3.0-9
- Removed Azure and Terremark driver because of unsatisfied dependencies

* Tue May 31 2011 Chris Lalancette <clalance@redhat.com> - 0.3.0-8
- Create sub-packages to bring in dependencies

* Tue May 31 2011 Michal Fojtik <mfojtik@redhat.com> - 0.3.0-7
- Added default config file in /etc/sysconfig/deltacloud-core

* Tue May 31 2011 Michal Fojtik <mfojtik@redhat.com> - 0.3.0-6
- Updated init.d script to match Fedora Guidelines

* Fri May 20 2011 Michal Fojtik <mfojtik@redhat.com> - 0.3.0-5
- Obsoleted rubygem-deltacloud-core

* Wed May 11 2011 Michal Fojtik <mfojtik@redhat.com> - 0.3.0-4
- Fixed memory calculation for RHEV-M (client)

* Wed May 11 2011 Michal Fojtik <mfojtik@redhat.com> - 0.3.0-3
- Fixed loadbalancer bug

* Thu May 5 2011 Michal Fojtik <mfojtik@redhat.com> - 0.3.0-2
- Fixed documentation generation
- Replaced moving with copying
- Removed support folder from doc subpackage

* Fri Apr 29 2011 Michal Fojtik <mfojtik@redhat.com> - 0.3.0-1
- Version bump

* Tue Mar 15 2011 Michal Fojtik <mfojtik@redhat.com> - 0.2.0-4
- Added missing runtime dependencies

* Mon Jan 31 2011 Michal Fojtik <mfojtik@redhat.com> - 0.2.0-3
- Removed cache and specification
- Added Sinatra to build dependecies

* Mon Jan 31 2011 Michal Fojtik <mfojtik@redhat.com> - 0.2.0-2
- Moved application to app_root (https://fedoraproject.org/wiki/Packaging_talk:Ruby#Applications)

* Mon Jan 31 2011 Michal Fojtik <mfojtik@redhat.com> - 0.2.0-1
- Initial package
